// Customizer start

// Customizer end
module __Customizer_Limit__ () {}

// production quality or not
production = 1;
pnghq = 0;

$resolution = (production && !$preview) ? 250 : (pnghq ? 250 : 25);

if (production && !$preview) {
	echo("Producing PRODUCTION quality");
    echo("Resolution",$resolution);
} else {
	echo("Producing DRAFT quality");
    echo("Resolution",$resolution);
}

use <MCAD/regular_shapes.scad>
use <MCAD/2Dshapes.scad>
include <sdcard-case-param.txt>;

module sdcard_case() {
	difference() {
		minkowski() {
			translate([
				$main_round
				, $main_round
				, 0
				]) {
				cube([
					$card_width + $xyborder*2 - $main_round*2
					, $card_length + $xyborder*2 + $flag_length - $main_round*2
					, $card_height + $zborder*2
					]);
			}
			cylinder(
					 h = .001
					 , r = $main_round
					 , $fn = $resolution
					 );
		}
		translate([
			$xyborder
			, $xyborder
			, $zborder
			]) {
			cube([
				$card_width
				, $card_length
				, $card_height + $zborder + .01
				]);
		}
		translate([
			($card_width-$total_spring_width + $xyborder*2)/2
			, ($card_length + $xyborder*2)/2
			, -.01
			]) {
			cylinder(h = $zborder + .02
					 , r = $hole_rad
					 , $fn = $resolution
					 );
		}

		// flag recess
		translate([
			$xyborder
			, $card_length + $xyborder*2
			, ($card_height + $zborder*2) - $flag_depth
			]) {
			cube([
				$card_width
				, $flag_length - $xyborder
				, $flag_depth + .01 
				]);
		}


	}

	// left side holder
	translate([
		$xyborder - .01
		, ($card_length + $xyborder*2)/2 - $tic_length/2
		, ($card_height + $zborder*2) - $tic_height + .01
		]) {

		difference() {
			hull() {
				translate([
					0
					, $tic_height/2
					, $tic_height
					]) {
					rotate([0,90,0]) {
						square_pyramid($tic_width, $tic_height, $tic_height);
					}
				}

				translate([
					0
					, $tic_length - $tic_height/2
					, $tic_height
					]) {
					rotate([0,90,0]) {
						square_pyramid($tic_width, $tic_height, $tic_height);
					}
				}
			}

			translate([
				-.5
				, -.5
				, $tic_height
				]) {
				cube([
					$tic_height + 1
					, $tic_length + 1
					, $tic_height + 1
					]);
			}
		}
	}


	// spring

	// base1
	translate([
		$card_width + $xyborder - $spring_base_width
		, $xyborder
		, $zborder
		]) {
		cube([
			$spring_base_width
			, $spring_base_depth
			, $card_height + $zborder
			]);
	}

	// base 2
	translate([
		$card_width + $xyborder - $spring_base_width
		, $card_length + $xyborder - $spring_base_depth
		, $zborder
		]) {
		cube([
			$spring_base_width
			, $spring_base_depth
			, $card_height + $zborder
			]);
	}

	// curve
	translate([
		$spring_rad + $card_width
		, $card_length/2 + $xyborder
		, ($zborder*2 + $card_height) - $spring_height
		]) {
		rotate([0,0,90]) {
			linear_extrude($spring_height) {
				donutSlice(
						   $spring_rad
						   , $spring_rad + $spring_width
						   , $spring_start_radians
						   , $spring_end_radians
						   , $fn=$resolution);
			}
		}
	}


	// spring tic
	translate([
		$xyborder + $card_width - $total_spring_width
		, ($card_length + $xyborder*2)/2 - $spring_tic_length/2
		, ($card_height + $zborder*2) - $spring_tic_height
		]) {

		rotate([0,0,180])
		translate([$total_spring_width-$spring_tic_width+.7,-$spring_tic_length,0])
		difference() {
			hull() {
				translate([
					0
					, $spring_tic_height/2
					, $spring_tic_height
					]) {
					rotate([0,90,0]) {
						square_pyramid($spring_tic_width, $spring_tic_height, $spring_tic_height);
					}
				}

				translate([
					0
					, $spring_tic_length - $spring_tic_height/2
					, $spring_tic_height
					]) {
					rotate([0,90,0]) {
						square_pyramid($spring_tic_width, $spring_tic_height, $spring_tic_height);
					}
				}
			}

			translate([
				-.5
				, -.5
				, $spring_tic_height
				]) {
				cube([
					$spring_tic_height + 1
					, $spring_tic_length + 1
					, $spring_tic_height + 1
					]);
			}
		}
	}

	
}

color([.8,.8,.8])
sdcard_case();
